// jQuery関連のライブラリ
google.load("jquery", "1");
google.load("jqueryui", "1");

// ステータス表示
function status(msg) {
	$("#status").html(msg);
}

// プログラムの遅延実行
// 待機中に呼び出された場合は、以前の実行登録を解除する
function execute() {
	$("#frame").stop().delay(2000).queue(function(){
		try {
			status("Execute.");
			eval($("#editer").val());
			status("Done.");
		} catch (e) {
			status("Error :" + e.message + " (line " + e.lineNumber + ")");
		}
		$(this).dequeue();
	});
}

//
// textarea のカーソル位置にテキストを挿入する
// http://d.hatena.ne.jp/spitfire_tree/20131209/1386575758
//
function insertAtCaret(target, str) {
	var obj = $(target);
	obj.focus();
	if(navigator.userAgent.match(/MSIE/)) {
		var r = document.selection.createRange();
		r.text = str;
		r.select();
	} else {
		var s = obj.val();
		var p = obj.get(0).selectionStart;
		var np = p + str.length;
		obj.val(s.substr(0, p) + str + s.substr(p));
		obj.get(0).setSelectionRange(np, np);
	}
}

// jQueryでファンクションキーやバックスペースキーを無効化する制御
// <http://jquery.nj-clucker.com/applied/ctrl_key_input_event_apply/>
function defaultKeyDown(event) {
	// クリックされたキーのコード
	var keyCode = event.keyCode;

	// Ctrlキーがクリックされたか (true or false)
	var ctrlClick = event.ctrlKey;

	// Altキーがクリックされたか (true or false)
	var altClick = event.altKey;

	// キーイベントが発生した対象のオブジェクト
	var obj = event.target;	// バックスペースキーを制御する

	if (keyCode == 8) {
		// テキストボックス／テキストエリアを制御する
		if ((obj.tagName == "INPUT" && obj.type == "TEXT")
			|| obj.tagName == "TEXTAREA") {
			// 入力できる場合は制御しない
			if (!obj.readOnly && !obj.disabled) {
				return true;
			}
		}
		return false;
	}
 
	// Alt + ←→を制御する
	if (altClick && (keyCode == 37 || keyCode == 39)) {
		return false;
	}
 
	// Ctrl + Nを制御する
	if (ctrlClick && keyCode == 78) {
		return false;
	}
}

// ファイルを読み切ってからイベントの設定
google.setOnLoadCallback(function() {
	// jQueryでファンクションキーやバックスペースキーを無効化する制御
	// <http://jquery.nj-clucker.com/applied/ctrl_key_input_event_apply/>

	// 更新時のプログラム実行
	$("#editer").change(function(){
		execute();
	});

	// バックスペースキーなどを無効化する制御
	$(document).keydown(function(event){
		return defaultKeyDown(event);
	});

	// エディタのキー制御
	$("#editer").keydown(function(event){
		var result = defaultKeyDown(event);

		switch (event.keyCode) {
		case 37:
		case 38:
		case 39:
		case 40:
			// カーソルキー
			break;

		case 9:
			// タブキーを入力に変換
			insertAtCaret("#editer", "	");
			result = false;

		default:
			// 入力時のプログラム実行
			execute();
			break;
		}

		return result;
	});
});
